Subject: Re: Google Summer of Code 2009

From: "Shawn O. Pearce" <[email-masked]>
Date: Mon, 12 Jan 2009 07:33:22 -0800

Johannes Schindelin <[email-masked]> wrote:
> On Mon, 12 Jan 2009, Andreas Ericsson wrote:
> 
> > Just chiming in that I can probably help mentoring whoever goes with 
> > libgit2. I do not have enough spare time for me to promise that I can be 
> > there as much as I think is necessary and proper, but I'll gladly help 
> > out.
> 
> I don't know if I like co-mentoring; I always had the impression that this 
> does not work all that well.

I haven't tried it myself, so I can't comment.  I thought though
that Daniel and Christian's mentoring went rather well, but maybe
that's just me.

This year I may not be able to be a mentor for GSoC.  Even assuming
we are selected again we're likely to only have two students, given
the size of the program and the size of our organization's community.
I will most likely be hosting an intern at day-job, and I do want
to maintain some sort of contribution to Git, without hurting my
day job performance... so my time this summer is probably going to
be somewhat limited.

> > On a side-note, I think all mentors should urge the students in the 
> > strongest possible terms to deliver their work to git@vger as soon as 
> > possible. From previous years experience, successful projects are those 
> > that the list sees code from within a week or two after the project's 
> > started, while the projects that are kept in the dark rarely (if ever?) 
> > finish successfully.
> 
> Nope, that is just plainly incorrect.
> 
> The most successful GSoC project we had was Miklos' builtin-merge, but the 
> code had to grow to a state that both him and me were comfortable with a 
> submission to git@vger.

Heh.  I'd wager the most successful GSoC project was Marek's push
support for JGit.  Having ObjectWriter available has opened up
the doors to support a lot of code in JGit, like the full protocol
suite, and bundles.  Without it I wouldn't have gotten as far as
I did in Gerrit.

In terms of value, to me as a contributor, Marek's work gave me a
foundation we could build on and get stuff done.  Miklos' merge is
great, but I don't think we gained nearly as many features as we
did with Marek's contribution.

Anyway, I don't want to get into a "my student was better!" contest.
I just think that we had a very successful year this year, with a
few really great projects being contributed to the community as a
result of our students' hard work.
 
> The _communication_ should be open, and much of it on the mailing list, I 
> agree, but _only_ after the student is familiar enough with the aspects of 
> her project (including some familiarity with the source code).
>
> I will _not_ force a student to ask questions openly that he finds 
> embarassing.

I agree.  The first few weeks are really critical to the student.  They
are still trying to find their way around the code base and don't want
to look like an idiot.  Nobody wants to look like an idiot, especially
in public, and especially when they have been "hired" to do a particular
job.

But... part of the reason GSoC exists is to get students involved
in open source.  The rest of us don't come to Git with mentors we
can ask the "stupid" questions to.  We come here and have to ask
what we need to ask, on the public mailing list, complete with
archives for the rest of time.  As mentors we should be trying to
encourage our students to work in this, or any other, open source
community.  GSoC is about getting these folks _involved_, so that
40 years from now, open source is just as viable as it is today.

-- 
Shawn.